﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using DlhSoft.Windows.Data;

namespace GanttChartTaskListViewCustomScheduleSample
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        public Window1()
        {
            InitializeComponent();
        }

        // Prepare custom schedule instances to be used as the default schedule, as a specific task schedule, and as a specific resource schedule.
        public static Schedule CustomDefaultSchedule
        {
            get
            {
                return new Schedule("Monday - Thursday, 8:00 AM - 12:30 PM, 1:30 - 3:00 PM",
                    delegate(Date date)
                    {
                        if (date.DayOfWeek >= DayOfWeek.Monday && date.DayOfWeek <= DayOfWeek.Thursday)
                        {
                            return new TimeIntervalCollection
                            {
                                new TimeInterval(date.Add(TimeSpan.Parse("08:00:00")), date.Add(TimeSpan.Parse("12:30:00"))),
                                new TimeInterval(date.Add(TimeSpan.Parse("13:30:00")), date.Add(TimeSpan.Parse("15:00:00")))
                            };
                        }
                        return null;
                    });
            }
        }
        public static Schedule CustomSpecialTaskSchedule
        {
            get
            {
                return new Schedule("Monday - Saturday, 9:00 AM - 2:00 PM",
                    delegate(Date date)
                    {
                        if (date.DayOfWeek >= DayOfWeek.Monday && date.DayOfWeek <= DayOfWeek.Saturday)
                        {
                            return new TimeIntervalCollection
                            {
                                new TimeInterval(date.Add(TimeSpan.Parse("09:00:00")), date.Add(TimeSpan.Parse("14:00:00")))
                            };
                        }
                        return null;
                    });
            }
        }
        public static Schedule CustomSpecialResourceSchedule
        {
            get
            {
                return new Schedule("Tuesday - Friday, 9:30 AM - 2:30 PM, excluding January 1, 2",
                    delegate(Date date)
                    {
                        if (date.Month == 1 && date.Day >= 1 && date.Day <= 2)
                            return null;
                        if (date.DayOfWeek >= DayOfWeek.Tuesday && date.DayOfWeek <= DayOfWeek.Friday)
                        {
                            return new TimeIntervalCollection
                            {
                                new TimeInterval(date.Add(TimeSpan.Parse("09:30:00")), date.Add(TimeSpan.Parse("14:30:00")))
                            };
                        }
                        return null;
                    });
            }
        }
    }
}
